<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>VSLProposalUtils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/marte/vsl/ui/contentassist/VSLProposalUtils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2010, 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  CEA LIST - Initial API and implementation</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.marte.vsl.ui.contentassist;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Date;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EClass;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.extensions.VSLContextUtil;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.scoping.visitors.ScopingVisitors;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.scoping.visitors.ScopingVisitors.Visitor_GetRecursivelyOwnedAndImportedMetaclassInstances;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.scoping.visitors.ScopingVisitors.Visitor_GetRecursivelyOwnedAndImportedStereotypeInstances;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.validation.VSLJavaValidator;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Behavior;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Enumeration;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.EnumerationLiteral;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.MultiplicityElement;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Namespace;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Operation;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Parameter;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ParameterDirectionKind;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PrimitiveType;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Stereotype;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLPackage;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/marte/vsl/ui/contentassist/VSLProposalUtils.html">VSLProposalUtils</a> {
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForType(Classifier classifier, MultiplicityElement elem) {
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  		Map&lt;String, Element&gt; allProposals = buildProposalForType(classifier);
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  		<strong class="jxr_keyword">if</strong> (elem.upperBound() == 1) {
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  			<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  		}
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  		Map&lt;String, Element&gt; allProposalsWithAccountForMultiplicity = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		<strong class="jxr_keyword">for</strong> (String s : allProposals.keySet()) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  			String displayString;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  			<strong class="jxr_keyword">if</strong> (!s.contains(<span class="jxr_string">"|"</span>)) {
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  				displayString = s;
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  			}
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  				String[] splitted = s.split(<span class="jxr_string">"|"</span>);
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  				displayString = splitted[0];
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  			}
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  			String newProposal = <span class="jxr_string">"{"</span> + displayString + <span class="jxr_string">"/* , "</span> + displayString + <span class="jxr_string">" */ }"</span>;
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  			allProposalsWithAccountForMultiplicity.put(newProposal, allProposals.get(s));
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  		}
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		<strong class="jxr_keyword">return</strong> allProposalsWithAccountForMultiplicity;
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  	}
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForType(Classifier classifier) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  		Map&lt;String, Element&gt; allProposals = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		<strong class="jxr_keyword">if</strong> (VSLContextUtil.isATupleType(classifier)) {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			allProposals.putAll(buildProposalForTupleType(classifier));
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  		}
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (VSLContextUtil.isAChoiceType(classifier)) {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			allProposals.putAll(buildProposalForChoiceType(classifier));
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		}
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (VSLContextUtil.isACollectionType(classifier)) {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  			allProposals.putAll(buildProposalForCollectionType(classifier));
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		}
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (classifier instanceof Enumeration) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			allProposals.putAll(buildProposalForEnumeration(classifier));
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		}
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (classifier instanceof PrimitiveType) {
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  			allProposals.putAll(buildProposalForPrimitiveType(classifier));
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		}
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (classifier instanceof Stereotype) {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			allProposals.putAll(buildProposalForStereotype(classifier));
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		}
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (classifier instanceof org.eclipse.uml2.uml.Class) {
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  			allProposals.putAll(buildProposalForMetaclass(classifier));
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  		}
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  			allProposals.put(<span class="jxr_string">"/* "</span> + classifier.getName() + <span class="jxr_string">"*/"</span>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		}
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		Map&lt;String, Element&gt; crossReferences = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		crossReferences.putAll(buildProposalForMetaclass(UMLPackage.eINSTANCE.getBehavior()));
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		List&lt;String&gt; proposalsToBeRemoved = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		<strong class="jxr_keyword">for</strong> (String key : crossReferences.keySet()) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 			Type behaviorReturnType = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 			Behavior behavior = (Behavior) crossReferences.get(key);
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 			;
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 			<strong class="jxr_keyword">for</strong> (Parameter p : behavior.getOwnedParameters()) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 				<strong class="jxr_keyword">if</strong> (p.getDirection() == ParameterDirectionKind.RETURN_LITERAL) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 					behaviorReturnType = p.getType();
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 				}
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 			}
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 			<strong class="jxr_keyword">if</strong> (behaviorReturnType == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 				proposalsToBeRemoved.add(key);
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> ((classifier.getName().equals(<span class="jxr_string">"Integer"</span>) || classifier.getName().equals(<span class="jxr_string">"Boolean"</span>) || classifier.getName().equals(<span class="jxr_string">"String"</span>))
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 					&amp;&amp; !behaviorReturnType.getName().equals(classifier.getName())) {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 				proposalsToBeRemoved.add(key);
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 			}
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (!behaviorReturnType.conformsTo(classifier)) {
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 				proposalsToBeRemoved.add(key);
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 			}
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		}
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		<strong class="jxr_keyword">for</strong> (String key : proposalsToBeRemoved) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 			crossReferences.remove(key);
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		}
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		<strong class="jxr_keyword">for</strong> (String key : crossReferences.keySet()) {
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 			Behavior calledBehavior = (Behavior) crossReferences.get(key);
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			allProposals.put(buildCompletionStringForBehaviorCall(calledBehavior) + <span class="jxr_string">"|"</span> + buildDisplayStringForBehaviorCall(calledBehavior), calledBehavior);
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		}
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		<em class="jxr_comment">// if the global context element is nested inside a classifier:</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		<em class="jxr_comment">// - retrieves the classifier, and gets all its owned and inherited attributes</em>
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		Element context = VSLJavaValidator.getContextElement();
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		<strong class="jxr_keyword">while</strong> (context != <strong class="jxr_keyword">null</strong> &amp;&amp; !(context instanceof Classifier)) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 			context = context.getOwner();
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		}
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		<strong class="jxr_keyword">if</strong> (context != <strong class="jxr_keyword">null</strong> &amp;&amp; context instanceof Classifier) {
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 			List&lt;Property&gt; allProperties = ((Classifier) context).getAllAttributes();
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 			<strong class="jxr_keyword">for</strong> (Property p : allProperties) {
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 				List&lt;Classifier&gt; classifiers = <strong class="jxr_keyword">new</strong> ArrayList&lt;Classifier&gt;();
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 				<em class="jxr_comment">// classifiers.add((Classifier)p.getType()) ;</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 				FeatureTree tree = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/marte/vsl/ui/contentassist/FeatureTree.html">FeatureTree</a>(p, classifiers);
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 				<strong class="jxr_keyword">if</strong> (tree.canClassifierBeReached(classifier)) {
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 					allProposals.put(p.getName(), p);
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 				}
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 			}
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		}
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 		<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 	}
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForTupleType(Classifier classifier) {
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		Map&lt;String, Element&gt; allProposals = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		String proposal = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		proposal += <span class="jxr_string">"{"</span>;
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		Property p = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		Property propertyValue = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		Property propertyUnit = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		<strong class="jxr_keyword">boolean</strong> first = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		<strong class="jxr_keyword">for</strong> (NamedElement n : VSLContextUtil.getTupleAttribs(classifier)) {
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 			p = (Property) n;
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 			<strong class="jxr_keyword">if</strong> (p.getType() != <strong class="jxr_keyword">null</strong> &amp;&amp; !p.getType().getName().equalsIgnoreCase(<span class="jxr_string">"VSL_Expression"</span>)) {
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 				<strong class="jxr_keyword">if</strong> (!first) {
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 					proposal += <span class="jxr_string">", "</span>;
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 				} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 					first = false;
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 				}
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 				proposal += p.getName() + <span class="jxr_string">" = /"</span>;
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 				<strong class="jxr_keyword">if</strong> (p.getName().equals(<span class="jxr_string">"value"</span>)) {
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 					propertyValue = p;
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 				} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (p.getName().equals(<span class="jxr_string">"unit"</span>)) {
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 					propertyUnit = p;
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 				}
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 			}
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 		}
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 		<strong class="jxr_keyword">if</strong> (propertyUnit != <strong class="jxr_keyword">null</strong> &amp;&amp; propertyValue != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 			<em class="jxr_comment">// This is a nfp type. Builds a short proposal with only value and unit, since these properties are more commonly used</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 			String shortProposal = <span class="jxr_string">"{unit = /, value = /}"</span>;
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 			allProposals.put(shortProposal, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 		}
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 		proposal += <span class="jxr_string">"}"</span>;
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 		allProposals.put(proposal, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 		<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 	}
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForChoiceType(Classifier classifier) {
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 		Map&lt;String, Element&gt; allProposals = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 		Property p = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 		<strong class="jxr_keyword">for</strong> (NamedElement n : VSLContextUtil.getChoiceAttribs(classifier)) {
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 			p = (Property) n;
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 			String choiceProposal = p.getName() + <span class="jxr_string">"("</span>;
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 			Map&lt;String, Element&gt; nestedProposals = buildProposalForType((Classifier) p.getType());
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 			<strong class="jxr_keyword">for</strong> (String nestedProposal : nestedProposals.keySet()) {
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 				allProposals.put(choiceProposal + nestedProposal + <span class="jxr_string">")"</span>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 			}
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 		}
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 	}
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForCollectionType(Classifier classifier) {
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 		Map&lt;String, Element&gt; allProposals = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 		Property p = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 		<strong class="jxr_keyword">if</strong> (VSLContextUtil.getCollectionAttrib(classifier) != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 			p = (Property) VSLContextUtil.getCollectionAttrib(classifier);
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 		}
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		<strong class="jxr_keyword">if</strong> (p.getType() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 			Map&lt;String, Element&gt; nestedProposals = buildProposalForType((Classifier) p.getType());
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 			<strong class="jxr_keyword">for</strong> (String nestedProposal : nestedProposals.keySet()) {
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 				allProposals.put(<span class="jxr_string">"{"</span> + nestedProposal + <span class="jxr_string">"}"</span>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 			}
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 		}
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 		<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 	}
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForEnumeration(Classifier classifier) {
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 		HashMap&lt;String, Element&gt; allProposals = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 		<strong class="jxr_keyword">for</strong> (EnumerationLiteral n : ((Enumeration) classifier).getOwnedLiterals()) {
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 			allProposals.put(n.getName(), n);
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 		}
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 		<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 	}
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForPrimitiveType(Classifier classifier) {
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 		Map&lt;String, Element&gt; allProposals = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 		<strong class="jxr_keyword">if</strong> (classifier.getName().contains(<span class="jxr_string">"Integer"</span>)) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 			allProposals.put(<span class="jxr_string">"1"</span>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 		}
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (classifier.getName().contains(<span class="jxr_string">"Real"</span>)) {
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 			allProposals.put(<span class="jxr_string">"1.0"</span>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 		}
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (classifier.getName().contains(<span class="jxr_string">"Natural"</span>)) {
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 			allProposals.put(<span class="jxr_string">"*"</span>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 		}
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (classifier.getName().contains(<span class="jxr_string">"DateTime"</span>)) {
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 			Date currentDate = <strong class="jxr_keyword">new</strong> Date();
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 			String year = <span class="jxr_string">""</span> + (currentDate.getYear() + 1900);
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 			String month = <span class="jxr_string">""</span> + currentDate.getMonth();
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 			<strong class="jxr_keyword">if</strong> (month.length() == 1) {
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 				month = <span class="jxr_string">"0"</span> + month;
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 			}
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 			String day = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 			<strong class="jxr_keyword">switch</strong> (currentDate.getDay()) {
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 			<strong class="jxr_keyword">case</strong> 0:
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 				day += <span class="jxr_string">"Sun"</span>;
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 			<strong class="jxr_keyword">case</strong> 1:
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 				day += <span class="jxr_string">"Mon"</span>;
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 			<strong class="jxr_keyword">case</strong> 2:
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 				day += <span class="jxr_string">"Tue"</span>;
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 			<strong class="jxr_keyword">case</strong> 3:
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 				day += <span class="jxr_string">"Wed"</span>;
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 			<strong class="jxr_keyword">case</strong> 4:
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 				day += <span class="jxr_string">"Thu"</span>;
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 			<strong class="jxr_keyword">case</strong> 5:
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 				day += <span class="jxr_string">"Fri"</span>;
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 			<strong class="jxr_keyword">default</strong>:
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 				day += <span class="jxr_string">"Sat"</span>;
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 			}
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 			String dayOfMonth = <span class="jxr_string">""</span> + currentDate.getDate();
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 			<strong class="jxr_keyword">if</strong> (dayOfMonth.length() == 1) {
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 				dayOfMonth = <span class="jxr_string">"0"</span> + dayOfMonth;
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 			}
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 			String hour = <span class="jxr_string">""</span> + currentDate.getHours();
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 			<strong class="jxr_keyword">if</strong> (hour.length() == 1) {
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 				hour = <span class="jxr_string">"0"</span> + hour;
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 			}
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 			String minute = <span class="jxr_string">""</span> + currentDate.getMinutes();
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 			<strong class="jxr_keyword">if</strong> (minute.length() == 1) {
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 				minute = <span class="jxr_string">"0"</span> + minute;
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 			}
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 			String second = <span class="jxr_string">""</span> + currentDate.getSeconds();
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 			<strong class="jxr_keyword">if</strong> (second.length() == 1) {
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 				second = <span class="jxr_string">"0"</span> + second;
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 			}
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 			String centi = <span class="jxr_string">"00"</span>;
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 			String dateString = year + <span class="jxr_string">"/"</span> + month + <span class="jxr_string">"/"</span> + dayOfMonth; <em class="jxr_comment">// opt1</em>
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 			String dateString_dayString = dateString + <span class="jxr_string">" "</span> + day; <em class="jxr_comment">// opt2</em>
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 			String timeString = hour + <span class="jxr_string">":"</span> + minute + <span class="jxr_string">":"</span> + second; <em class="jxr_comment">// opt3</em>
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 			String timeString_dateString_dayString = timeString + <span class="jxr_string">" "</span> + dateString + <span class="jxr_string">" "</span> + day; <em class="jxr_comment">// opt4</em>
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 			String timeString_dayString = timeString + <span class="jxr_string">" "</span> + day; <em class="jxr_comment">// opt5</em>
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 			String timeString_dateString = timeString + <span class="jxr_string">" "</span> + dateString; <em class="jxr_comment">// opt6</em>
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 			String dayString = day; <em class="jxr_comment">// opt7</em>
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 			allProposals.put(timeString_dateString_dayString, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 			allProposals.put(timeString_dayString, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 			allProposals.put(timeString_dateString, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 			allProposals.put(timeString, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 			allProposals.put(dateString_dayString, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 			allProposals.put(dateString, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 			allProposals.put(dayString, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L298" href="#L298">298</a> 
<a class="jxr_linenumber" name="L299" href="#L299">299</a> 			<em class="jxr_comment">// &lt;datetime-literal&gt; ::= (&lt;date-string&gt; [&lt;daystring&gt;] ) | ( &lt;time-string&gt; [&lt;datestring&gt;]</em>
<a class="jxr_linenumber" name="L300" href="#L300">300</a> 			<em class="jxr_comment">// [&lt;day-string&gt;] ) | ( &lt;day-string&gt; )</em>
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 			<em class="jxr_comment">// &lt;time-string&gt; ::= &lt;hr&gt; [':' &lt;min&gt; [':' &lt;sec&gt; [':' &lt;centisec&gt;] ] ]</em>
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 			<em class="jxr_comment">// &lt;hr&gt; ::= '00'..'23'</em>
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 			<em class="jxr_comment">// &lt;min&gt; ::= '00'..'59'</em>
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 			<em class="jxr_comment">// &lt;sec&gt; ::= '00'..'59'</em>
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 			<em class="jxr_comment">// &lt;centisec&gt; ::= '00'..'99'</em>
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 			<em class="jxr_comment">// &lt;date-string&gt; ::= &lt;year&gt; '/' &lt;mon&gt; '/' &lt;day-of-mon&gt;</em>
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 			<em class="jxr_comment">// &lt;year&gt; ::= '0000'..'9999'</em>
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 			<em class="jxr_comment">// &lt;mon&gt; ::= '01'..'12'</em>
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 			<em class="jxr_comment">// &lt;day-of-mon&gt; ::= '01'..'31'</em>
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 			<em class="jxr_comment">// &lt;day-string&gt; ::= 'Mon' | 'Tue' | 'Wed' | 'Thr' | 'Fri' | 'Sat' | 'Sun'</em>
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 		}
<a class="jxr_linenumber" name="L312" href="#L312">312</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (classifier.getName().contains(<span class="jxr_string">"Boolean"</span>)) {
<a class="jxr_linenumber" name="L313" href="#L313">313</a> 			allProposals.put(<span class="jxr_string">"true"</span>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L314" href="#L314">314</a> 			allProposals.put(<span class="jxr_string">"false"</span>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L315" href="#L315">315</a> 		}
<a class="jxr_linenumber" name="L316" href="#L316">316</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (classifier.getName().contains(<span class="jxr_string">"String"</span>)) {
<a class="jxr_linenumber" name="L317" href="#L317">317</a> 			allProposals.put(<span class="jxr_string">"\&quot;value\&quot;"</span>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L318" href="#L318">318</a> 		}
<a class="jxr_linenumber" name="L319" href="#L319">319</a> 		<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L320" href="#L320">320</a> 	}
<a class="jxr_linenumber" name="L321" href="#L321">321</a> 
<a class="jxr_linenumber" name="L322" href="#L322">322</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForStereotype(Classifier classifier) {
<a class="jxr_linenumber" name="L323" href="#L323">323</a> 		List&lt;Element&gt; allElements = <strong class="jxr_keyword">new</strong> ArrayList&lt;Element&gt;();
<a class="jxr_linenumber" name="L324" href="#L324">324</a> 		Map&lt;String, Element&gt; allProposals = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L325" href="#L325">325</a> 		<strong class="jxr_keyword">new</strong> ScopingVisitors.Visitor_GetRecursivelyOwnedAndImportedStereotypeInstances();
<a class="jxr_linenumber" name="L326" href="#L326">326</a> 		allElements.addAll(Visitor_GetRecursivelyOwnedAndImportedStereotypeInstances.visit(VSLJavaValidator.getModel(), (Stereotype) classifier));
<a class="jxr_linenumber" name="L327" href="#L327">327</a> 		<strong class="jxr_keyword">for</strong> (Element c : allElements) {
<a class="jxr_linenumber" name="L328" href="#L328">328</a> 			<strong class="jxr_keyword">if</strong> (c instanceof NamedElement) {
<a class="jxr_linenumber" name="L329" href="#L329">329</a> 				allProposals.put(getNameLabel((NamedElement) c), c);
<a class="jxr_linenumber" name="L330" href="#L330">330</a> 			}
<a class="jxr_linenumber" name="L331" href="#L331">331</a> 		}
<a class="jxr_linenumber" name="L332" href="#L332">332</a> 		<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L333" href="#L333">333</a> 	}
<a class="jxr_linenumber" name="L334" href="#L334">334</a> 
<a class="jxr_linenumber" name="L335" href="#L335">335</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForMetaclass(Classifier classifier) {
<a class="jxr_linenumber" name="L336" href="#L336">336</a> 		List&lt;Element&gt; allElements = <strong class="jxr_keyword">new</strong> ArrayList&lt;Element&gt;();
<a class="jxr_linenumber" name="L337" href="#L337">337</a> 		Map&lt;String, Element&gt; allProposals = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L338" href="#L338">338</a> 		<strong class="jxr_keyword">new</strong> ScopingVisitors.Visitor_GetRecursivelyOwnedAndImportedMetaclassInstances();
<a class="jxr_linenumber" name="L339" href="#L339">339</a> 		allElements.addAll(Visitor_GetRecursivelyOwnedAndImportedMetaclassInstances.visit(VSLJavaValidator.getModel(), (org.eclipse.uml2.uml.Class) classifier));
<a class="jxr_linenumber" name="L340" href="#L340">340</a> 		<strong class="jxr_keyword">for</strong> (Element c : allElements) {
<a class="jxr_linenumber" name="L341" href="#L341">341</a> 			<strong class="jxr_keyword">if</strong> (c instanceof NamedElement) {
<a class="jxr_linenumber" name="L342" href="#L342">342</a> 				allProposals.put(getNameLabel((NamedElement) c), c);
<a class="jxr_linenumber" name="L343" href="#L343">343</a> 			}
<a class="jxr_linenumber" name="L344" href="#L344">344</a> 		}
<a class="jxr_linenumber" name="L345" href="#L345">345</a> 		<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L346" href="#L346">346</a> 	}
<a class="jxr_linenumber" name="L347" href="#L347">347</a> 
<a class="jxr_linenumber" name="L348" href="#L348">348</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> Map&lt;String, Element&gt; buildProposalForMetaclass(EClass metaclass) {
<a class="jxr_linenumber" name="L349" href="#L349">349</a> 		List&lt;Element&gt; allElements = <strong class="jxr_keyword">new</strong> ArrayList&lt;Element&gt;();
<a class="jxr_linenumber" name="L350" href="#L350">350</a> 		Map&lt;String, Element&gt; allProposals = <strong class="jxr_keyword">new</strong> HashMap&lt;String, Element&gt;();
<a class="jxr_linenumber" name="L351" href="#L351">351</a> 		<strong class="jxr_keyword">new</strong> ScopingVisitors.Visitor_GetRecursivelyOwnedAndImportedMetaclassInstances();
<a class="jxr_linenumber" name="L352" href="#L352">352</a> 		allElements.addAll(Visitor_GetRecursivelyOwnedAndImportedMetaclassInstances.visit(VSLJavaValidator.getModel(), metaclass));
<a class="jxr_linenumber" name="L353" href="#L353">353</a> 		<strong class="jxr_keyword">for</strong> (Element c : allElements) {
<a class="jxr_linenumber" name="L354" href="#L354">354</a> 			<strong class="jxr_keyword">if</strong> (c instanceof NamedElement) {
<a class="jxr_linenumber" name="L355" href="#L355">355</a> 				allProposals.put(getNameLabel((NamedElement) c), c);
<a class="jxr_linenumber" name="L356" href="#L356">356</a> 			}
<a class="jxr_linenumber" name="L357" href="#L357">357</a> 		}
<a class="jxr_linenumber" name="L358" href="#L358">358</a> 		<strong class="jxr_keyword">return</strong> allProposals;
<a class="jxr_linenumber" name="L359" href="#L359">359</a> 	}
<a class="jxr_linenumber" name="L360" href="#L360">360</a> 
<a class="jxr_linenumber" name="L361" href="#L361">361</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String getNameLabel(NamedElement elem) {
<a class="jxr_linenumber" name="L362" href="#L362">362</a> 		String label = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L363" href="#L363">363</a> 
<a class="jxr_linenumber" name="L364" href="#L364">364</a> 		Namespace model = VSLJavaValidator.getModel();
<a class="jxr_linenumber" name="L365" href="#L365">365</a> 		List&lt;Package&gt; importedPackages = <strong class="jxr_keyword">new</strong> ArrayList&lt;Package&gt;(model.getImportedPackages());
<a class="jxr_linenumber" name="L366" href="#L366">366</a> 
<a class="jxr_linenumber" name="L367" href="#L367">367</a> 		List&lt;Namespace&gt; visitedNamespaces = <strong class="jxr_keyword">new</strong> ArrayList&lt;Namespace&gt;();
<a class="jxr_linenumber" name="L368" href="#L368">368</a> 		Namespace currentNamespace = elem.getNamespace();
<a class="jxr_linenumber" name="L369" href="#L369">369</a> 
<a class="jxr_linenumber" name="L370" href="#L370">370</a> 		<strong class="jxr_keyword">boolean</strong> rootFound = false;
<a class="jxr_linenumber" name="L371" href="#L371">371</a> 
<a class="jxr_linenumber" name="L372" href="#L372">372</a> 		<strong class="jxr_keyword">while</strong> (currentNamespace != <strong class="jxr_keyword">null</strong> &amp;&amp; !rootFound) {
<a class="jxr_linenumber" name="L373" href="#L373">373</a> 			visitedNamespaces.add(currentNamespace);
<a class="jxr_linenumber" name="L374" href="#L374">374</a> 			<strong class="jxr_keyword">if</strong> (importedPackages.contains(currentNamespace) || currentNamespace == model) {
<a class="jxr_linenumber" name="L375" href="#L375">375</a> 				rootFound = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L376" href="#L376">376</a> 			}
<a class="jxr_linenumber" name="L377" href="#L377">377</a> 			Element owner = currentNamespace.getOwner();
<a class="jxr_linenumber" name="L378" href="#L378">378</a> 
<a class="jxr_linenumber" name="L379" href="#L379">379</a> 			currentNamespace = owner != <strong class="jxr_keyword">null</strong> ? (Namespace) owner : <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L380" href="#L380">380</a> 		}
<a class="jxr_linenumber" name="L381" href="#L381">381</a> 
<a class="jxr_linenumber" name="L382" href="#L382">382</a> 		<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = visitedNamespaces.size() - 1; i &gt;= 0; i--) {
<a class="jxr_linenumber" name="L383" href="#L383">383</a> 			label += visitedNamespaces.get(i).getName() + <span class="jxr_string">"::"</span>;
<a class="jxr_linenumber" name="L384" href="#L384">384</a> 		}
<a class="jxr_linenumber" name="L385" href="#L385">385</a> 
<a class="jxr_linenumber" name="L386" href="#L386">386</a> 		<strong class="jxr_keyword">return</strong> label + elem.getName();
<a class="jxr_linenumber" name="L387" href="#L387">387</a> 	}
<a class="jxr_linenumber" name="L388" href="#L388">388</a> 
<a class="jxr_linenumber" name="L389" href="#L389">389</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String buildDisplayStringForBehaviorCall(Behavior calledBehavior) {
<a class="jxr_linenumber" name="L390" href="#L390">390</a> 		String label = calledBehavior.getName() + <span class="jxr_string">"("</span>;
<a class="jxr_linenumber" name="L391" href="#L391">391</a> 		String returnTypeName = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L392" href="#L392">392</a> 		List&lt;String&gt; parameterLabels = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L393" href="#L393">393</a> 		<strong class="jxr_keyword">for</strong> (Parameter p : calledBehavior.getOwnedParameters()) {
<a class="jxr_linenumber" name="L394" href="#L394">394</a> 			<strong class="jxr_keyword">if</strong> (p.getDirection() == ParameterDirectionKind.RETURN_LITERAL) {
<a class="jxr_linenumber" name="L395" href="#L395">395</a> 				returnTypeName = p.getType().getName();
<a class="jxr_linenumber" name="L396" href="#L396">396</a> 			}
<a class="jxr_linenumber" name="L397" href="#L397">397</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L398" href="#L398">398</a> 				String parameterLabel = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L399" href="#L399">399</a> 				<strong class="jxr_keyword">switch</strong> (p.getDirection()) {
<a class="jxr_linenumber" name="L400" href="#L400">400</a> 				<strong class="jxr_keyword">case</strong> IN_LITERAL:
<a class="jxr_linenumber" name="L401" href="#L401">401</a> 					parameterLabel += <span class="jxr_string">"in "</span>;
<a class="jxr_linenumber" name="L402" href="#L402">402</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L403" href="#L403">403</a> 				<strong class="jxr_keyword">case</strong> OUT_LITERAL:
<a class="jxr_linenumber" name="L404" href="#L404">404</a> 					parameterLabel += <span class="jxr_string">"out "</span>;
<a class="jxr_linenumber" name="L405" href="#L405">405</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L406" href="#L406">406</a> 				<strong class="jxr_keyword">case</strong> INOUT_LITERAL:
<a class="jxr_linenumber" name="L407" href="#L407">407</a> 					parameterLabel += <span class="jxr_string">"inout "</span>;
<a class="jxr_linenumber" name="L408" href="#L408">408</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L409" href="#L409">409</a> 				<strong class="jxr_keyword">default</strong>:
<a class="jxr_linenumber" name="L410" href="#L410">410</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L411" href="#L411">411</a> 				}
<a class="jxr_linenumber" name="L412" href="#L412">412</a> 				parameterLabel += p.getName() + <span class="jxr_string">" : "</span> + p.getType().getName();
<a class="jxr_linenumber" name="L413" href="#L413">413</a> 				parameterLabels.add(parameterLabel);
<a class="jxr_linenumber" name="L414" href="#L414">414</a> 			}
<a class="jxr_linenumber" name="L415" href="#L415">415</a> 		}
<a class="jxr_linenumber" name="L416" href="#L416">416</a> 		<strong class="jxr_keyword">boolean</strong> first = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L417" href="#L417">417</a> 		<strong class="jxr_keyword">for</strong> (String parameterLabel : parameterLabels) {
<a class="jxr_linenumber" name="L418" href="#L418">418</a> 			<strong class="jxr_keyword">if</strong> (!first) {
<a class="jxr_linenumber" name="L419" href="#L419">419</a> 				label += <span class="jxr_string">", "</span>;
<a class="jxr_linenumber" name="L420" href="#L420">420</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L421" href="#L421">421</a> 				first = false;
<a class="jxr_linenumber" name="L422" href="#L422">422</a> 			}
<a class="jxr_linenumber" name="L423" href="#L423">423</a> 			label += parameterLabel;
<a class="jxr_linenumber" name="L424" href="#L424">424</a> 		}
<a class="jxr_linenumber" name="L425" href="#L425">425</a> 
<a class="jxr_linenumber" name="L426" href="#L426">426</a> 		<strong class="jxr_keyword">return</strong> label + <span class="jxr_string">") : "</span> + returnTypeName;
<a class="jxr_linenumber" name="L427" href="#L427">427</a> 	}
<a class="jxr_linenumber" name="L428" href="#L428">428</a> 
<a class="jxr_linenumber" name="L429" href="#L429">429</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String buildCompletionStringForBehaviorCall(Behavior calledBehavior) {
<a class="jxr_linenumber" name="L430" href="#L430">430</a> 		String label = calledBehavior.getName() + <span class="jxr_string">"("</span>;
<a class="jxr_linenumber" name="L431" href="#L431">431</a> 		List&lt;String&gt; parameterLabels = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L432" href="#L432">432</a> 		<strong class="jxr_keyword">for</strong> (Parameter p : calledBehavior.getOwnedParameters()) {
<a class="jxr_linenumber" name="L433" href="#L433">433</a> 			<strong class="jxr_keyword">if</strong> (p.getDirection() == ParameterDirectionKind.RETURN_LITERAL) {
<a class="jxr_linenumber" name="L434" href="#L434">434</a> 				<em class="jxr_comment">// ignore</em>
<a class="jxr_linenumber" name="L435" href="#L435">435</a> 			}
<a class="jxr_linenumber" name="L436" href="#L436">436</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L437" href="#L437">437</a> 				parameterLabels.add(p.getName());
<a class="jxr_linenumber" name="L438" href="#L438">438</a> 			}
<a class="jxr_linenumber" name="L439" href="#L439">439</a> 		}
<a class="jxr_linenumber" name="L440" href="#L440">440</a> 		<strong class="jxr_keyword">boolean</strong> first = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L441" href="#L441">441</a> 		<strong class="jxr_keyword">for</strong> (String parameterLabel : parameterLabels) {
<a class="jxr_linenumber" name="L442" href="#L442">442</a> 			<strong class="jxr_keyword">if</strong> (!first) {
<a class="jxr_linenumber" name="L443" href="#L443">443</a> 				label += <span class="jxr_string">", "</span>;
<a class="jxr_linenumber" name="L444" href="#L444">444</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L445" href="#L445">445</a> 				first = false;
<a class="jxr_linenumber" name="L446" href="#L446">446</a> 			}
<a class="jxr_linenumber" name="L447" href="#L447">447</a> 			label += parameterLabel;
<a class="jxr_linenumber" name="L448" href="#L448">448</a> 		}
<a class="jxr_linenumber" name="L449" href="#L449">449</a> 
<a class="jxr_linenumber" name="L450" href="#L450">450</a> 		<strong class="jxr_keyword">return</strong> label + <span class="jxr_string">")"</span>;
<a class="jxr_linenumber" name="L451" href="#L451">451</a> 	}
<a class="jxr_linenumber" name="L452" href="#L452">452</a> 
<a class="jxr_linenumber" name="L453" href="#L453">453</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String buildDisplayStringForOperationCall(Operation calledOperation) {
<a class="jxr_linenumber" name="L454" href="#L454">454</a> 		String label = calledOperation.getName() + <span class="jxr_string">"("</span>;
<a class="jxr_linenumber" name="L455" href="#L455">455</a> 		String returnTypeName = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L456" href="#L456">456</a> 		List&lt;String&gt; parameterLabels = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L457" href="#L457">457</a> 		<strong class="jxr_keyword">for</strong> (Parameter p : calledOperation.getOwnedParameters()) {
<a class="jxr_linenumber" name="L458" href="#L458">458</a> 			<strong class="jxr_keyword">if</strong> (p.getDirection() == ParameterDirectionKind.RETURN_LITERAL) {
<a class="jxr_linenumber" name="L459" href="#L459">459</a> 				returnTypeName = p.getType().getName();
<a class="jxr_linenumber" name="L460" href="#L460">460</a> 			}
<a class="jxr_linenumber" name="L461" href="#L461">461</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L462" href="#L462">462</a> 				String parameterLabel = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L463" href="#L463">463</a> 				<strong class="jxr_keyword">switch</strong> (p.getDirection()) {
<a class="jxr_linenumber" name="L464" href="#L464">464</a> 				<strong class="jxr_keyword">case</strong> IN_LITERAL:
<a class="jxr_linenumber" name="L465" href="#L465">465</a> 					parameterLabel += <span class="jxr_string">"in "</span>;
<a class="jxr_linenumber" name="L466" href="#L466">466</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L467" href="#L467">467</a> 				<strong class="jxr_keyword">case</strong> OUT_LITERAL:
<a class="jxr_linenumber" name="L468" href="#L468">468</a> 					parameterLabel += <span class="jxr_string">"out "</span>;
<a class="jxr_linenumber" name="L469" href="#L469">469</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L470" href="#L470">470</a> 				<strong class="jxr_keyword">case</strong> INOUT_LITERAL:
<a class="jxr_linenumber" name="L471" href="#L471">471</a> 					parameterLabel += <span class="jxr_string">"inout "</span>;
<a class="jxr_linenumber" name="L472" href="#L472">472</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L473" href="#L473">473</a> 				<strong class="jxr_keyword">default</strong>:
<a class="jxr_linenumber" name="L474" href="#L474">474</a> 					<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L475" href="#L475">475</a> 				}
<a class="jxr_linenumber" name="L476" href="#L476">476</a> 				parameterLabel += p.getName() + <span class="jxr_string">" : "</span> + p.getType().getName();
<a class="jxr_linenumber" name="L477" href="#L477">477</a> 				parameterLabels.add(parameterLabel);
<a class="jxr_linenumber" name="L478" href="#L478">478</a> 			}
<a class="jxr_linenumber" name="L479" href="#L479">479</a> 		}
<a class="jxr_linenumber" name="L480" href="#L480">480</a> 		<strong class="jxr_keyword">boolean</strong> first = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L481" href="#L481">481</a> 		<strong class="jxr_keyword">for</strong> (String parameterLabel : parameterLabels) {
<a class="jxr_linenumber" name="L482" href="#L482">482</a> 			<strong class="jxr_keyword">if</strong> (!first) {
<a class="jxr_linenumber" name="L483" href="#L483">483</a> 				label += <span class="jxr_string">", "</span>;
<a class="jxr_linenumber" name="L484" href="#L484">484</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L485" href="#L485">485</a> 				first = false;
<a class="jxr_linenumber" name="L486" href="#L486">486</a> 			}
<a class="jxr_linenumber" name="L487" href="#L487">487</a> 			label += parameterLabel;
<a class="jxr_linenumber" name="L488" href="#L488">488</a> 		}
<a class="jxr_linenumber" name="L489" href="#L489">489</a> 
<a class="jxr_linenumber" name="L490" href="#L490">490</a> 		<strong class="jxr_keyword">return</strong> label + <span class="jxr_string">") : "</span> + returnTypeName;
<a class="jxr_linenumber" name="L491" href="#L491">491</a> 	}
<a class="jxr_linenumber" name="L492" href="#L492">492</a> 
<a class="jxr_linenumber" name="L493" href="#L493">493</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String buildCompletionStringForOperationCall(Operation calledOperation) {
<a class="jxr_linenumber" name="L494" href="#L494">494</a> 		String label = calledOperation.getName() + <span class="jxr_string">"("</span>;
<a class="jxr_linenumber" name="L495" href="#L495">495</a> 		List&lt;String&gt; parameterLabels = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L496" href="#L496">496</a> 		<strong class="jxr_keyword">for</strong> (Parameter p : calledOperation.getOwnedParameters()) {
<a class="jxr_linenumber" name="L497" href="#L497">497</a> 			<strong class="jxr_keyword">if</strong> (p.getDirection() == ParameterDirectionKind.RETURN_LITERAL) {
<a class="jxr_linenumber" name="L498" href="#L498">498</a> 				<em class="jxr_comment">// ignore</em>
<a class="jxr_linenumber" name="L499" href="#L499">499</a> 			}
<a class="jxr_linenumber" name="L500" href="#L500">500</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L501" href="#L501">501</a> 				parameterLabels.add(p.getName());
<a class="jxr_linenumber" name="L502" href="#L502">502</a> 			}
<a class="jxr_linenumber" name="L503" href="#L503">503</a> 		}
<a class="jxr_linenumber" name="L504" href="#L504">504</a> 		<strong class="jxr_keyword">boolean</strong> first = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L505" href="#L505">505</a> 		<strong class="jxr_keyword">for</strong> (String parameterLabel : parameterLabels) {
<a class="jxr_linenumber" name="L506" href="#L506">506</a> 			<strong class="jxr_keyword">if</strong> (!first) {
<a class="jxr_linenumber" name="L507" href="#L507">507</a> 				label += <span class="jxr_string">", "</span>;
<a class="jxr_linenumber" name="L508" href="#L508">508</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L509" href="#L509">509</a> 				first = false;
<a class="jxr_linenumber" name="L510" href="#L510">510</a> 			}
<a class="jxr_linenumber" name="L511" href="#L511">511</a> 			label += parameterLabel;
<a class="jxr_linenumber" name="L512" href="#L512">512</a> 		}
<a class="jxr_linenumber" name="L513" href="#L513">513</a> 
<a class="jxr_linenumber" name="L514" href="#L514">514</a> 		<strong class="jxr_keyword">return</strong> label + <span class="jxr_string">")"</span>;
<a class="jxr_linenumber" name="L515" href="#L515">515</a> 	}
<a class="jxr_linenumber" name="L516" href="#L516">516</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
